﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------


using Newtonsoft.Json;

namespace CommonInterface
{
    [JsonObject(MemberSerialization.OptIn)]
    public class Address
    {
        #region Serialize
        [JsonProperty]
        public int ID { get; set; }
        [JsonProperty]
        public string HouseNumber { get; set; }
        [JsonProperty]
        public string HouseName { get; set; }
        [JsonProperty]
        public string Appartment { get; set; }
        [JsonProperty]
        public string Street { get; set; }
        [JsonProperty]
        public string AdministrativeArea { get; set; }
        [JsonProperty]
        public string District { get; set; }
        [JsonProperty]
        public string Town { get; set; }
        [JsonProperty]
        public string PostCode { get; set; }
        [JsonProperty]
        public Country Country { get; set; }
        #endregion
        #region Non Serialize
        public virtual void SetTestValues()
        {
            ID = 5678;
            HouseName = "GonRoamin";
            HouseNumber = "42a";
            Appartment = "BlockOFlats";
            Street = "Arcadia Avenue";
            AdministrativeArea = "Admin Area";
            District = "District";
            Town = "MyTown";
            PostCode = "AA01 1AA";
            Country c = new Country();
            c.SetTestValues();
            Country = c;
        }
        #endregion
    }
}
