﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using Newtonsoft.Json;

namespace CommonInterface
{
    [JsonObject(MemberSerialization.OptIn)]
    public class Communication
    {
        #region Serialize
        [JsonProperty]
        public  int ID { get; set; }
        [JsonProperty]
        public People Communicatee { get; set; }  
        [JsonProperty]
        public Staff Communicator { get; set; }
        [JsonProperty]
        public string Type { get; set; }
        [JsonProperty]
        public string Importance { get; set; }
        [JsonProperty]
        public string Direction { get; set; }
        [JsonProperty]
        public string Summary { get; set; }
        [JsonProperty]
        public string LogConfidentiality { get; set; }
        [JsonProperty]
        public string Subject { get; set; }
        [JsonProperty]
        Dictionary<int, People> About = new Dictionary<int, People>();
        [JsonProperty]
        public bool FollowUpRequired { get; set; }
        [JsonProperty]
        public DateTime FollowUpOn { get; set; }
        #endregion
        #region NonSerialize
        public void SetTestData()
        {
            People p = new People();
            p.SetTestValues();
            Communicatee = p;
            Staff s = new Staff();
            s.SetTestValues();
            Communicator = s;
            Type = "Prospectus Sent";
            Importance = "High";
            Direction = "Sent";
            FollowUpRequired = true;
            FollowUpOn = DateTime.Now;
            LogConfidentiality = "Public";
            Summary = "Sent prospectus out as requested by ...";
            Subject = "Other";
            About.Add(p.ID, p);
        }
        #endregion
    }
}
