﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using Newtonsoft.Json;


namespace CommonInterface
{
    [JsonObject(MemberSerialization.OptIn)]
    public class DocumentLink
    {
        #region Serialize
        [JsonProperty]
        public int ID { get; set; }
        [JsonProperty]
        public string Summary { get; set; }
        [JsonProperty]
        public string Type { get; set; }
        [JsonProperty]
        public string Status { get; set; }
        [JsonProperty]
        public string Note { get; set; }
        [JsonProperty]
        public string AttachmentFileName { get; set; }
        [JsonProperty]
        public Staff Owner { get; set; }  // Staff Link
        [JsonProperty]
        public DateTime LastUpdate { get; set; } // Set is for display only any save will update it 
        #endregion
        #region Non Serialize
        public void SetTestValues()
        {
            ID = 999;
            Summary = "Summary Text";
            Type = "General";
            Status = "Public";
            Note = "Notes ... ";
            AttachmentFileName = @"c:\temp\filename.txt";
            Staff s = new Staff();
            s.SetTestValues();
            Owner = s;
            LastUpdate = DateTime.Now;

        }
        #endregion

    }
}
