﻿// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMSInterface
{
    public class SIMSApplication
    {
        public int SIMSApplicationId { get; set; }
        public Applicant ApplicantLink { get; set; }
        public string ApplicationStatus { get; set; }
        public string IntakeGroup { get; set; }
        public string ApplicationReferenceNumber { get; set; }
        public void Load(int applicationID)
        {
            SIMS.Processes.Admissions.MaintainApplication app = new SIMS.Processes.Admissions.MaintainApplication();
            bool maintAppBool = app.RetrieveApplication(applicationID);
            ApplicantLink = new Applicant(app.DetailedApplication.Applicant);
            ApplicationStatus = app.DetailedApplication.Status.Code;
            IntakeGroup = app.DetailedApplication.AppliedIntakeGroup.Name;
            SIMSApplicationId = applicationID;

            ApplicationReferenceNumber = app.DetailedApplication.ApplicationReferenceNumber;


            //Accept Admission
            //SIMS.Processes.Admissions.AcceptApplicationDetail accept = new SIMS.Processes.Admissions.AcceptApplicationDetail();

            //accept.Populate(1043, 1);
            //string test = "";

            //accept.Save();
            //Addmission Browse
        }

    }
}
